/********************************************************************************/
/* Name		: LdapSettings.java												*/
/* Copyright: 2003 SATCOMLABS LTD.				     			*/
/* Team		: Spam Control Team													*/
/* Developer: Virendra Singh Royal												*/
/* Last Updated	: 24/06/2006															*/
/* Abstract		: Servertype and ldapstring is updated															*/
/* Called from	: ldapsettings.jsp															*/
/* Calls		: ldapsettings.jsp															*/
/********************************************************************************/

package com.antispam;

import java.net.*;
import java.io.*;
import java.sql.*;
import com.DBConnection;
import com.replace.Replace;
//import com.SocketConnection;

public class LdapSettings
{
      DBConnection dbconn = new DBConnection ();
      Replace rep = new Replace ();
//	  SocketConnection socketconn =new SocketConnection();
      
      public int hiddomainid = 0;
	 
/* --------Following has been updated by Vijay Singh Rathore--------- */

public String ldapString="";
public String serverType ="";
public String txtTransDomain = "";
public String domainname = "";

public int autoadd = 0;

public void  setAutoadd(int i)
{
	
	autoadd =i;
}

public int getAutoadd()
{
	
	return autoadd;
}

public String transqry = null;
public String domainqry = null;

public void setTxtTransDomain( String s )
      {	  txtTransDomain = s;      }
      public String getTxtTransDomain( )
      {	  return txtTransDomain;      }


/* SET-GET  the value of ldapString*/
public void setLdapString ( String s )
      {	  ldapString = s;      }
      public String getLdapString ( )
      {	  return ldapString;      }


/* SET-GET  the value of radLDAPActicated*/
public void setServerType ( String s )
      {	  serverType = s;      }
 public String getServerType ( )
      {	  return serverType;      }

/* --------Above has been updated by Vijay Singh Rathore--------- */

         /* SET-GET  DOMAIN ID*/
      public void setHiddomainid ( int s )
      {	  hiddomainid = s;      }
      public int getHiddomainid ( )
      {	  return hiddomainid;      }

	    
	//METHOD FOR FETCHING THE RECORDS
	public void registered ( )
	{
		java.sql.Connection conn = null;
		java.sql.Statement smt = null;
	    java.sql.ResultSet rs = null;
				
		String qry = null;
		
		try
		{
			conn = dbconn.getConnection(); 
			smt = conn.createStatement();
			
			qry = "SELECT d.ldapstring,d.servertype FROM DOMAINS d,domaintransformation dt WHERE d.DomainID="+hiddomainid;
			rs = smt.executeQuery( qry );    /*qry has been updated by Vijay Singh Rathore on 16/05/06 by adding d.serverType,d.ldapString in select statement */                                                                                                                                             
			if ( rs.next() )
			{
							
				setLdapString(rs.getString(1));
				setServerType(rs.getString(2));
			}
			else
			{
			}
			if ( rs != null )
				rs = null;
		}
		catch ( java.sql.SQLException sqle )
		{	System.out.println("SQLE Exception-->"+sqle);
			
		}
		catch ( Exception e )
		{	System.out.println("Exception-->"+e);
			e.printStackTrace();
		}
		finally
		{
			try {
				smt.close();
				conn.close();
			} catch ( Exception ignored ) {}
		}
	}

//Method for manipulating ldapString before saving it to the database
public void trimLdapString() 
	{
		String s2="",s4="";
		
		int l,end=0;
		
		l=ldapString.length();

		while((end=ldapString.indexOf(":")) != -1)
		{
			s2=ldapString.substring(0,end+1);
			ldapString=ldapString.substring(end+1,l);
			
			s2=s2.trim();
			
			s4=s4.concat(s2);
			l=l-(end+1);
		}

	s4=s4.concat(ldapString);
	
	       while(s4.indexOf("::") != -1)
		{
			s4=s4.replaceAll("::",": :");
		}
	ldapString=s4;
	}




	//METHOD FOR UPDATING THE RECORDS
	public String savesettings( ) 
	{
		java.sql.Connection conn = null;
		java.sql.Statement smt = null;
	    java.sql.ResultSet rs = null;
		java.sql.ResultSet domainrs = null;

		String qry = null;
		String mesg =null;
		
		
		try
		{
			conn = dbconn.getConnection();
			smt = conn.createStatement();
			
			trimLdapString();
/*above code will replace all :: occurings in ldapString with : : */				
			
			
			
		qry = "UPDATE DOMAINS SET "+
										
"serverType = '"+serverType+"', "+
"ldapstring = '"+ldapString+"', " +
"autoadd = "+ autoadd +" WHERE DomainID = "+hiddomainid+" ";
				
				smt.executeUpdate ( qry );
				
				
				
				selectUpdateDefault( conn,smt);
				
					domainqry = "SELECT DOMAINNAME FROM DOMAINS WHERE DomainID="+hiddomainid+" ";
					domainrs = smt.executeQuery( domainqry );
					if ( domainrs.next() )
					{
						domainname = domainrs.getString(1);
					}
					else
					{}
					if ( domainrs != null )
					domainrs = null;
					
				if(txtTransDomain == null || txtTransDomain.equals(""))
				{
					transqry = "update domaintransformation set data='"+domainname+"' where domainid="+hiddomainid+"";  
				}

				else	
				{
					transqry = "update domaintransformation set data='"+txtTransDomain+"'where domainid="+hiddomainid+" ";  	
				}	
				smt.executeUpdate( transqry );
				
				if ( rs != null )
					rs = null;
								
												
				mesg = "LDAP Settings Successfully Updated";

				//qry = "SELECT DOMAINNAME FROM DOMAINS WHERE DOMAINID="+hiddomainid;
				//rs = smt.executeQuery( qry );
				//if(rs.next())
				//{
				//	domainname = rs.getString( 1 );
				//}
				//socketconn.listenSocket("UpdateDomain:"+domainname);
		}
		catch ( Exception e )
		{	System.out.println("Exception-->"+e);
			e.printStackTrace();
			mesg = "Unable to Update LDAP Settings";
		}
		finally
		{
			try {
				smt.close();
				conn.close();
			} catch ( Exception ignored ) {}
		}
		return mesg;
	}
/// this function is called from ldapsetting when save button is presed.





	private void selectUpdateDefault(Connection conn , Statement smt )
	{
		
		
				
		String lstr_sql = "select serverType ,ldapstring,autoadd from domains WHERE DomainID = "+hiddomainid+"";
		try{
			
				ResultSet rs = smt.executeQuery( lstr_sql );
				if ( rs.next() )
				{
					setAutoadd( rs.getInt("autoadd") );
					setServerType( rs.getString("serverType") );
					setLdapString( rs.getString("ldapstring") );
					
					
					rs.close();
				}
				
		  }catch(Exception er) { System.out.println("Error---------"); }
	}
	
	///called initailly when the page is loaded...
	
			public void selectDefault(int dmn_id)
		{
			
							
			
					java.sql.Connection conn = null;
					java.sql.Statement smt = null;
	    			java.sql.ResultSet rs = null;
		
					String qry = null;
					String mesg =null;
					
						try
						{
							
							
							conn = dbconn.getConnection();
							
							
							smt = conn.createStatement();
							
							
							qry = "select serverType,ldapstring,autoadd from domains "+ " where domainid = "+dmn_id+" ";
							
							rs = smt.executeQuery ( qry );
							
							
							if (rs.next() )
							{setAutoadd( rs.getInt("autoadd") );
							setServerType( rs.getString("serverType") );
							setLdapString( rs.getString("ldapstring" ) );
							}
							
							
							
							smt.close();
							
						}catch(Exception e)
						{
							System.out.println("Error executing : " + qry + "------" );
							e.printStackTrace();
						}
		}
	
	
	///-----------------------------------paste it herer------------------
	
	
		public boolean savingsettings( ) 
	{
		java.sql.Connection conn = null;
		java.sql.Statement smt = null;
	    java.sql.ResultSet rs = null;
		java.sql.ResultSet domainrs = null;

		String qry = null;
		String mesg =null;
		
		boolean isUpdated = false;
		
		
		
		try
		{
			conn = dbconn.getConnection();
			smt = conn.createStatement();
			
			trimLdapString();
/*above code will replace all :: occurings in ldapString with : : */				
			
			
			
		qry = "UPDATE DOMAINS SET "+
										
"serverType = '"+serverType+"', "+
"ldapstring = '"+ldapString+"', " +
"autoadd = "+ autoadd +" WHERE domainid = "+hiddomainid+" ";
			
			
			
					
			int i=	smt.executeUpdate ( qry );
				
				
				
				if ( i != 0 )
				{
					isUpdated = true;
				}
				
		
				//socketconn.listenSocket("UpdateDomain:"+domainname);
		}
		catch ( Exception e )
		{	System.out.println("Exception=====================-->"+e);
			e.printStackTrace();
		isUpdated = false;
		}
		finally
		{
			try {
				smt.close();
				conn.close();
			} catch ( Exception ignored ) {}
		}
		return isUpdated;
	}
	
	

}
